
#include "render_area.hpp"

#include <GL/glu.h>
#include <iostream>

#include <QPainter>
#include <QMouseEvent>


render_area::render_area(QWidget *parent)
    :QWidget(parent)
{
    setBackgroundRole(QPalette::Base);
    setAutoFillBackground(true);
    draw_circle=true;
}

render_area::~render_area()
{}



void render_area::paintEvent(QPaintEvent*)
{
    //la classe qui permet de "dessiner"
    QPainter painter(this);
    painter.setRenderHint(QPainter::Antialiasing, true);

    //le pinceau de dessin
    QPen pen;

    pen.setWidth(4.0);
    pen.setColor(Qt::blue);
    painter.setPen(pen);

    QBrush brush = painter.brush();
    brush.setColor(Qt::gray);
    brush.setStyle(Qt::SolidPattern);
    painter.setBrush(brush);

    if(draw_circle)
        painter.drawEllipse(200,100,200,100);

}

void render_area::change_draw_circle()
{
    draw_circle=!draw_circle;
    repaint();
}
