
#include "render_area.hpp"

#include <GL/glu.h>
#include <iostream>

#include <QPainter>
#include <QMouseEvent>


render_area::render_area(QWidget *parent)
    :QWidget(parent)
{
    setBackgroundRole(QPalette::Base);
    setAutoFillBackground(true);
    draw_circle=true;

    x_old=0;
    y_old=0;

    xc=200;
    yc=150;
    diametre=150;
}

render_area::~render_area()
{}



void render_area::paintEvent(QPaintEvent*)
{
    //la classe qui permet de "dessiner"
    QPainter painter(this);
    painter.setRenderHint(QPainter::Antialiasing, true);

    //le pinceau de dessin
    QPen pen;

    pen.setWidth(4.0);
    pen.setColor(Qt::blue);
    painter.setPen(pen);

    QBrush brush = painter.brush();
    brush.setColor(Qt::gray);
    brush.setStyle(Qt::SolidPattern);
    painter.setBrush(brush);

    if(draw_circle)
        painter.drawEllipse(xc,yc,diametre,diametre);


}

void render_area::change_draw_circle()
{
    draw_circle=!draw_circle;
    repaint();
}

void render_area::mousePressEvent(QMouseEvent *event)
{
    x_old=event->x();
    y_old=event->y();

}

void render_area::mouseMoveEvent(QMouseEvent *event)
{
    int x=event->x();
    int y=event->y();

    int R=diametre/2.0f;
    int x0=xc+R;
    int y0=yc+R;

    if( (x-x0)*(x-x0)+(y-y0)*(y-y0)<R*R )
    {
        xc+=(x-x_old);
        yc+=(y-y_old);
    }

    x_old=x;
    y_old=y;
    repaint();
}


