#include "monWidgetGL.hpp"

#include <GL/glu.h>
#include "glutils.hpp"

#include <iostream>

monWidgetGL::monWidgetGL(const QGLFormat& format,QGLWidget *parent) :
    QGLWidget(format,parent)
{
    etat_affichage=true;
}

monWidgetGL::~monWidgetGL()
{}

void monWidgetGL::initializeGL()
{
    std::cout<<"appel monWidgetGL::initializeGL()"<<std::endl;

    glewInit();
    float sommets[]={0,0,0,
                     0.5,0,0,
                     0,1,0};

    glClearColor(0.0, 1.0, 1.0, 0.0);
    glEnable(GL_DEPTH_TEST);

    //attribution d'un buffer de donnees (1 indique la création d'un buffer)
    glGenBuffers(1,&vbo); PRINT_OPENGL_ERROR();
    //affectation du buffer courant
    glBindBuffer(GL_ARRAY_BUFFER,vbo); PRINT_OPENGL_ERROR();
    //copie des donnees des sommets sur la carte graphique
    glBufferData(GL_ARRAY_BUFFER,sizeof(sommets),sommets,GL_STATIC_DRAW);
    PRINT_OPENGL_ERROR();


    // Chargement du shader
    shader_program_id = read_shader("shader.vert", "shader.frag");PRINT_OPENGL_ERROR();


    //activation de la gestion de la profondeur
    glEnable(GL_DEPTH_TEST); PRINT_OPENGL_ERROR();


}




void monWidgetGL::paintGL()
{
    glClearColor(0.5, 0.6, 0.9, 1.0);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

    if(etat_affichage==true)
    {
        glBindBuffer(GL_ARRAY_BUFFER,vbo); PRINT_OPENGL_ERROR();
        glEnableClientState(GL_VERTEX_ARRAY); PRINT_OPENGL_ERROR();
        glVertexPointer(3, GL_FLOAT, 0, 0); PRINT_OPENGL_ERROR();
        glDrawArrays(GL_TRIANGLES, 0, 3); PRINT_OPENGL_ERROR();
    }
}



void monWidgetGL::afficher()
{
    etat_affichage=!etat_affichage;
std::cout<<etat_affichage<<std::endl;
    updateGL();
}
void monWidgetGL::wireframe(bool est_actif)
{
    if(est_actif==true)
        glPolygonMode( GL_FRONT_AND_BACK, GL_LINE);
    else
        glPolygonMode( GL_FRONT_AND_BACK, GL_FILL);

    updateGL();
}
